import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

class OperationSystem {
    String  productName;
    double  marketShare;

    // constracter
    public OperationSystem(String osname, double share) {
        this.productName = osname;
        this.marketShare = share;
    }

    public String toString() {  // for System.out.println
        return this.productName + " : " + this.marketShare + "%";
    }
}

// sort/reverse key : productName
class ProductNameComparator implements Comparator {
    public int compare(Object o1, Object o2) {
        return ((OperationSystem)o1).productName.compareTo(((OperationSystem)o2).productName);
    }
}

// sort/reverse key : marketShare
class MarketShareComparator implements Comparator {
    public int compare(Object o1, Object o2) {
        if (((OperationSystem)o2).marketShare < ((OperationSystem)o1).marketShare) return 1;
        if (((OperationSystem)o2).marketShare > ((OperationSystem)o1).marketShare) return -1;
        return 0;
    }
}

public class OrigListSort2 {
    @SuppressWarnings("unchecked")
    public static void main(String[] args) {
        ArrayList<OperationSystem> osl = new ArrayList<OperationSystem>();

        // set data
        osl.add(new OperationSystem("ZZ OS", 3.0D));
        osl.add(new OperationSystem("AA OS", 27.0D));
        osl.add(new OperationSystem("aa OS", 7.0D));
        osl.add(new OperationSystem("zz OS", 2.0D));
        osl.add(new OperationSystem("CC OS", 49.0D));
        osl.add(new OperationSystem("cc OS", 1.0D));

        System.out.println("-- TARGET DATA --\n" + osl);

        System.out.println("-- productName sort --");
        Collections.sort(osl, new ProductNameComparator());
        System.out.println("sort: " + osl);

        System.out.println("-- productName reverse --");
        Collections.sort(osl, new ProductNameComparator());
        Collections.reverse(osl);
        System.out.println("reverse: " + osl);

        System.out.println("-- marketShare sort --");
        Collections.sort(osl, new MarketShareComparator());
        System.out.println("sort: " + osl);

        System.out.println("-- marketShare -reverse -");
        Collections.sort(osl, new MarketShareComparator());
        Collections.reverse(osl);
        System.out.println("reverse: " + osl);
    }
}
